
#include "TROOT.h"
#include "TSystem.h"

#include <iostream>
#include <string>

void rootlogon()
{
  // reading G4 include path and library
  char* c_g4 = getenv("G4SMLIBDIR");
  if(c_g4){
    std::string G4install_dir(c_g4);
    std::string G4include_path = "-I"+G4install_dir+"/include";
    AddIncludePath(G4include_path.c_str());

    std::string module_smdata = G4install_dir+"/lib/libsmdata.so";
    LoadModule(module_smdata.c_str());

    std::string module_smutil = G4install_dir+"/lib/libsmutil.so";
    LoadModule(module_smutil.c_str());
  }else{
    std::cout << "set environment variable \"G4SMLIBDIR\"" << std::endl;
    std::cout << "quit ROOT" << std::endl;      
    gROOT->ProcessLine(".q");
  }

//  // reading ANAROOT include path and library (if you need)
//  char* c_tart = getenv("TARTSYS");
//  if(c_tart){
//    std::string TArt_dir(c_tart);
//    std::string TArtinclude_path = "-I"+TArt_dir+"/include";
//    AddIncludePath(TArtinclude_path.c_str());
//    AddIncludePath("`xml2-config --cflags`");
//
//    std::string module_anaroot = TArt_dir+"/lib/libanaroot.so";
//    LoadModule(module_anaroot.c_str());
//  }else{
//    std::cout << "set environment variable \"TARTSYS\"" << std::endl;
//    std::cout << "quit ROOT" << std::endl;      
//    gROOT->ProcessLine(".q");
//  }

}

void AddIncludePath(std::string include_path)
{
  gSystem->AddIncludePath(include_path.c_str());
  std::cout << "add include path : " << include_path << std::endl;
}

void LoadModule(std::string module)
{
  std::cout << "reading " << module << std::endl;
  if(gSystem->Load(module.c_str()) < 0){
    std::cout << "cannnot read in " << module << std::endl;      
  }
}
