#!/usr/bin/perl

@Layer;
@SubLayer;
@DetType;
@PosX;
@PosY;
@PosZ;
@SizX;
@SizY;
@SizZ;
@AngleX;
@AngleY;
@AngleZ;

# Plastic size of  Neut and Veto
$Siz_n_x = 12.0;
$Siz_n_y = 180.0;
$Siz_n_z = 12.0;
$Siz_v_x = 32.0;
$Siz_v_y = 190.0;
$Siz_v_z = 1.0;

$VetoNumLayer = 12;
$NeutNumSubLayer = 30;
$VetoNumLayer = 12;
$NeutIDCenter = 15.5;
$VetoIDCenter = 6.5;
$DistLayer = 84.6;
$DistVetoNeut = 26.0;
$DistNeutNeutX = 0.24;
$DistNeutNeutZ = 1.0;
$DistVetoVetoZ = 1.5;
$VetoOverWrapX = 1.0;

$WholeShiftX = 12.7;
$WholeShiftY = 0;
$WholeShiftZ = 0;
#$WholeShiftZ = 1111.7;
$NeutWholeShiftZ = 0;

$ID=1;
$iSubLayerSeq=1;

#for Neutron Detector (ID=1:120)
while($iSubLayerSeq<5){
    for ($ineut=1;$ineut<=$NeutNumSubLayer;++$ineut){
	$Layer[$ID] = ($iSubLayerSeq+1)/2;
	$Layer[$ID] = int $Layer[$ID];
	$SubLayer[$ID] = ($iSubLayerSeq+1)%2+1;
	$DetType[$ID] = "Neut";
	$PosX[$ID] = -($ineut-$NeutIDCenter)*($Siz_n_x+$DistNeutNeutX);
	$PosY[$ID] = 0;
	$PosZ[$ID] = ($Layer[$ID]-1)*$DistLayer;
	if ($SubLayer[$ID]==2){$PosZ[$ID] += $Siz_n_z + $DistNeutNeutZ;}
	$SizX[$ID] = $Siz_n_x;
	$SizY[$ID] = $Siz_n_y;
	$SizZ[$ID] = $Siz_n_z;
	$ID++;
    }
    $iSubLayerSeq++;
}

#for Veto Detector (ID=121:144)
$iLayer = 1;
while($iLayer<3){
    for ($iveto=1;$iveto<=$VetoNumLayer;++$iveto){
	$Layer[$ID]  = $iLayer;
	$Sublayer[$ID] = 0;
	$DetType[$ID] = "Veto";
	$PosX[$ID] = -($iveto-$VetoIDCenter)*($Siz_v_x-$VetoOverWrapX);
	$PosY[$ID] = 0;
	$PosZ[$ID] = ($iLayer-1)*$DistLayer - $DistVetoNeut;
	if ($ID%2==1) {$PosZ[$ID] -= $DistVetoVetoZ;}
	$SizX[$ID] = $Siz_v_x;
	$SizY[$ID] = $Siz_v_y;
	$SizZ[$ID] = $Siz_v_z;
	$ID++;
    }
    $iLayer++;
}

for ($i=1;$i<145;++$i){
    $PosX[$i] += $WholeShiftX;
    $PosY[$i] += $WholeShiftY;
    $PosZ[$i] += $WholeShiftZ;
}

print "ID, DetecType, Layer, SubLayer, PositionX, PositionY, PositionZ, RotAngleX, RotAngleY, RotAngleZ,\n";
for ($i=1;$i<145;++$i){
    printf("%3i, %s, %2i, %2i, %7.2f, %7.1f, %7.1f, %5.1f, %5.1f, %5.1f,\n",
	   $i,$DetType[$i], $Layer[$i],$SubLayer[$i],
	   $PosX[$i],$PosY[$i],$PosZ[$i],
	   $RotAngleX[$i],$RotAngleY[$i],$RotAngleZ[$i]
	);
}
