#ifndef ACTIONSEQUENTIALDECAYMESSENGER_HH
#define ACTIONSEQUENTIALDECAYMESSENGER_HH

#include "G4UImessenger.hh"

class G4UIdirectory;
class G4UIcmdWithoutParameter;
class G4UIcmdWithABool;
class G4UIcmdWithAString;
class G4UIcmdWithAnInteger;
class G4UIcmdWithADoubleAndUnit;
class PrimaryGeneratorActionSequentialDecay;
class ActionCommonVariable;

// singleton pattern
class ActionSequentialDecayMessenger : public G4UImessenger
{
public:
  static ActionSequentialDecayMessenger* GetInstance();
  virtual ~ActionSequentialDecayMessenger();

  void Register(PrimaryGeneratorActionSequentialDecay* primaryGeneratorActionSequentialDecay);

  void SetNewValue(G4UIcommand*, G4String);

protected:
  static ActionSequentialDecayMessenger* fActionSequentialDecayMessenger;

  PrimaryGeneratorActionSequentialDecay* fPrimaryGeneratorActionSequentialDecay;
  ActionCommonVariable* fActionCommonVariable;

  G4UIdirectory* fActionSequentialDecayDir;
  G4UIcmdWithoutParameter* fSeqDecayCmd;
  G4UIcmdWithADoubleAndUnit* fSeqDecayErelCmd;
  G4UIcmdWithADoubleAndUnit* fSeqDecayErel012Cmd;
  G4UIcmdWithAnInteger* fSeqDecayAbeamCmd;
  G4UIcmdWithAnInteger* fSeqDecayZbeamCmd;
  G4UIcmdWithAnInteger* fSeqDecayAcoreCmd;
  G4UIcmdWithAnInteger* fSeqDecayZcoreCmd;

private: // hidden
  ActionSequentialDecayMessenger();
  ActionSequentialDecayMessenger(const ActionSequentialDecayMessenger& actionMessenger);
  ActionSequentialDecayMessenger& operator=(const ActionSequentialDecayMessenger& actionMessenger);
};

#endif

