#ifndef PRIMARYGENERATORACTIONSEQUENTIALDECAY_HH
#define PRIMARYGENERATORACTIONSEQUENTIALDECAY_HH

#include "PrimaryGeneratorActionBasic.hh"
#include "G4VUserPrimaryGeneratorAction.hh"
#include "globals.hh"

class G4ParticleGun;
class G4ParticleDefinition;

class TRandom3;
class TGenPhaseSpace;
class TLorentzVector;

class ActionBasicMessenger;
class ActionSequentialDecayMessenger;

class PrimaryGeneratorActionSequentialDecay : public PrimaryGeneratorActionBasic 
{
public:
  PrimaryGeneratorActionSequentialDecay(G4int seed = 128);
  virtual ~PrimaryGeneratorActionSequentialDecay();

  bool SetBeamType(G4String beamType);
  void GeneratePrimaries(G4Event*);

  virtual void AccumulateBeamData(G4Event* anEvent);

  void BeamTypeSequentialDecay(G4Event* anEvent);
  bool SetErel012(G4double erel);
  bool InitSequentialDecay();

protected:

  TRandom3* fRandom0;
  TRandom3* fRandom1;

  G4bool fOKInitSequentialDecay;
  G4double fErel012;
  double fMasses[NDECAY_MAX];

  TGenPhaseSpace* fPhaseSpace0;

  void (PrimaryGeneratorActionSequentialDecay::*beamFunctionPtr)(G4Event*);

  ActionBasicMessenger* fActionBasicMessenger;
  ActionSequentialDecayMessenger* fActionSequentialDecayMessenger;
};

#endif


