#ifndef DETECTORCONSTRUCTIONNeuLAND_HH
#define DETECTORCONSTRUCTIONNeuLAND_HH

#include "G4VUserDetectorConstruction.hh"
#include <TString.h>
#include <vector>


class G4LogicalVolume;
class G4Material;
class G4VSensitiveDetector;
class DetectorConstruction;
class DetectorConstructionNeuLANDMessenger;
class TargetConstruction;
class NeutronWindowConstruction;
class DipoleConstruction;
class NeutronDetectorConstruction;
class TSimulationParameterNeuLAND;


class DetectorConstructionNeuLAND : public G4VUserDetectorConstruction
{
public:
  DetectorConstructionNeuLAND();
  virtual ~DetectorConstructionNeuLAND();

  G4VPhysicalVolume* Construct();
  G4LogicalVolume* ConstructSub();

  void UpdateGeometry();
  void ReadParameterNeutronDetector(const char* PrmFileName);
  void ReadParameterNeuLAND(const char* PrmFileName);
  void CSVToVector(const char* PrmFileName, std::vector<std::vector<TString> >* PrmArray);

protected:
  DetectorConstructionNeuLANDMessenger* fDetectorConstructionNeuLANDMessenger;

  TargetConstruction* fTargetConstruction;
  NeutronWindowConstruction* fNeutronWindowConstruction;
  DipoleConstruction* fDipoleConstruction;
  NeutronDetectorConstruction* fNeutronDetectorConstruction;

  G4LogicalVolume* fLogicWorld;
  G4LogicalVolume* fLogicTarget;
  G4LogicalVolume* fLogicNeutronWindow;
  G4LogicalVolume* fLogicDipole;
  G4LogicalVolume* fLogicNeuLAND;
  G4LogicalVolume* fLogicNeut;
  G4LogicalVolume* fLogicVeto;
  G4LogicalVolume* fLogicAir;

  G4Material* fWorldMaterial;
  G4Material* fAirMaterial;
  G4Material* fNeuLANDMaterial;// AIR/Galactic for Mother volume of detectors
  G4Material* fNeutMaterial;

  G4VSensitiveDetector* fScintillatorSD;

};

#endif

