#ifndef __TPRIMARYPARTICLE__
#define __TPRIMARYPARTICLE__

#include "TObject.h"
#include "TLorentzVector.h"
#include "TVector3.h"
#include "TString.h"
#include <vector>

class TPrimaryParticle;
typedef std::vector<TPrimaryParticle> TPrimaryParticleArray;
extern TPrimaryParticleArray *gPrimaryParticleArray;

class TPrimaryParticle : public TObject
{

public:
  TPrimaryParticle();
  TPrimaryParticle(TString name, TLorentzVector mom, TVector3 pos);
  TPrimaryParticle(Int_t z, Int_t a, TLorentzVector mom, TVector3 pos);
  ~TPrimaryParticle();

  const TString*        GetParticleName() const {return &fParticleName;}
  const Int_t           GetZ()const {return fZ;}
  const Int_t           GetA()const {return fA;}
  const TLorentzVector* GetMomentum() const {return &fMomentum;}
  const TVector3*       GetPosition()const {return &fPosition;}

  void SetParticleName(TString name){fParticleName=name;}
  void SetZ(Int_t z){fZ=z;}
  void SetA(Int_t a){fA=a;}
  void SetMomentum(TLorentzVector mom){fMomentum=mom;}
  void SetPosition(TVector3 pos){fPosition=pos;}

private:
  TString        fParticleName;
  Int_t          fZ;
  Int_t          fA;
  TLorentzVector fMomentum;
  TVector3       fPosition;

  ClassDef(TPrimaryParticle,1)
};

#endif

