#ifndef TSIMULATIONPARAMETERNeuLAND_HH
#define TSIMULATIONPARAMETERNeuLAND_HH

#include "TNamed.h"
#include "TString.h"
#include "TVector3.h"

#include <map>

class TSimulationParameterNeutronDetector;

class TSimulationParameterNeuLAND;
extern TSimulationParameterNeuLAND* gSimulationParameterNeuLAND;

class TSimulationParameterNeuLAND : public TNamed
{
public:
  TSimulationParameterNeuLAND();
  TSimulationParameterNeuLAND(const char* name, const char* title = "");
  TSimulationParameterNeuLAND(const TString& name, const TString& title = "");
  virtual ~TSimulationParameterNeuLAND();

  std::map<int,TSimulationParameterNeutronDetector*>* GetParaNeutDetecMap(){return &fParaNeutDetecMap;}

  friend ostream& operator<<(ostream& out,  const TSimulationParameterNeuLAND& simulationParameterNeuLAND);

public:
  bool     fIsLoaded;
  Int_t    fNeutNum;// Total number of Neutron detectors
  Int_t    fVetoNum;// Total number of Veto detectors
  Int_t    fLayerNum;// Total number of Layers
  Int_t    fSubLayerNum; // Total number of SubLayers
  Int_t    fNeutNumLayer;// Total number of Neutron detectors per 1 layer
  Int_t    fVetoNumLayer;// Total number of Neutron detectors per 1 layer
  Int_t    fNeutNumSubLayer;// Total number of Neutron detectors per 1 wall
  Int_t    fVetoNumSubLayer;// Total number of Neutron detectors per 1 wall
  TVector3 fPosition;// position of whole system
  TVector3 fNeutSize;// size of Neut
  TVector3 fVetoSize;// size of Veto
  TVector3 fSize;// size of whole system (for Mother volume def.)
  TVector3 fRotAngle;// 0: rot angle around X-axis (deg), 1:Y, 2:Z

  std::map<int,TSimulationParameterNeutronDetector*> fParaNeutDetecMap;


  ClassDef(TSimulationParameterNeuLAND, 1)
};

#endif
