#ifndef TSIMULATIONPARAMETERNEUTRONDETECTOR_HH
#define TSIMULATIONPARAMETERNEUTRONDETECTOR_HH

#include "TNamed.h"
#include "TString.h"
#include "TVector3.h"

class TSimulationParameterNeutronDetector;
extern TSimulationParameterNeutronDetector* gSimulationParameterNeutronDetector;

class TSimulationParameterNeutronDetector : public TNamed
{
public:
  TSimulationParameterNeutronDetector();
  TSimulationParameterNeutronDetector(const char* name, const char* title = "");
  TSimulationParameterNeutronDetector(const TString& name, const TString& title = "");
  virtual ~TSimulationParameterNeutronDetector();

  friend ostream& operator<<(ostream& out,  const TSimulationParameterNeutronDetector& simulationParameterNeutronDetector);

public:
  Int_t    fID;
  Int_t    fLayer;      // 1,2,3,...
  Int_t    fSubLayer;   // 1,2 for Neut, 0 for Veto
  Int_t    fSubLayerSeq;// = (fLayer-1)*2 + fSubLayer for NEBULA
  TString  fDetecType;  // Neut or Veto
  TVector3 fPosition;
  TVector3 fRotAngle;   // 0: rot angle around X-axis (deg), 1:Y, 2:Z

  ClassDef(TSimulationParameterNeutronDetector, 1)
};

#endif
