
#include "TDataInitializerOneDetector.hh"

#include "TFile.h"
#include "TTree.h"

#include <iostream>

#include "TSimulationDataBeam.hh"
#include "TSimulationParameterGlobal.hh"
#include "TSimulationDataScintillator.hh"

ClassImp(TDataInitializerOneDetector)

TDataInitializerOneDetector::TDataInitializerOneDetector()
  : TDataInitializerInterface()
{;}

TDataInitializerOneDetector::~TDataInitializerOneDetector()
{;}

int TDataInitializerOneDetector::Initialize()
{
  delete gSimulationDataBeamArray; gSimulationDataBeamArray = 0;
  delete gSimulationDataScintillatorArray; gSimulationDataScintillatorArray = 0;
  gSimulationDataBeamArray = new TSimulationDataBeamArray;
  gSimulationDataScintillatorArray = new TSimulationDataScintillatorArray;

  return 1;
}

int TDataInitializerOneDetector::CreateBranch(TTree* tree)
{
  tree->Branch("beam", gSimulationDataBeamArray);
  tree->Branch("detector", gSimulationDataScintillatorArray);

  return 1;
}

int TDataInitializerOneDetector::AddParameters(TFile* file)
{
  file->Add(gSimulationParameterGlobal);

  return 1;
}

int TDataInitializerOneDetector::RemoveParameters(TFile* file)
{
  file->Remove(gSimulationParameterGlobal);

  return 1;
}

int TDataInitializerOneDetector::PrintParameters(TFile* file)
{
  std::cout << "\n parameters of TDataInitializerOneDetector:" << std::endl;

  TSimulationParameterGlobal* simParaGlobal;

  file->GetObject("parameterGlobal", simParaGlobal);
  if(!simParaGlobal){
    std::cerr << " SimParaGlobal does not exist" << std::endl;
    return 0;
  }
  std::cout << " " << *simParaGlobal << "\n"
    	    << std::endl;

  return 1;
}

int TDataInitializerOneDetector::ClearBuffer()
{
  gSimulationDataScintillatorArray->clear();

  return 1;
}
