
#include "TSimulationParameterMoNA.hh"
#include "TSimulationParameterNeutronDetector.hh"

#include <iostream>

ClassImp(TSimulationParameterMoNA)

TSimulationParameterMoNA* gSimulationParameterMoNA = 0;

//_____________________________________________________________________________
std::ostream& operator<<(std::ostream& out, const TSimulationParameterMoNA& simulationParameterMoNA)
{
  out << "fNeutNum = "<<simulationParameterMoNA.fNeutNum << "\n";
  out << "fVetoNum = "<<simulationParameterMoNA.fVetoNum << "\n";
  out << "fLayerNum = "<<simulationParameterMoNA.fLayerNum << "\n";
  out << "fSubLayerNum = "<<simulationParameterMoNA.fSubLayerNum << "\n";
  out << "fNeutNumLayer = "<<simulationParameterMoNA.fNeutNumLayer << "\n";
  out << "fVetoNumLayer = "<<simulationParameterMoNA.fVetoNumLayer << "\n";
  out << "fNeutNumSubLayer = "<<simulationParameterMoNA.fNeutNumSubLayer << "\n";
  out << "fVetoNumSubLayer = "<<simulationParameterMoNA.fVetoNumSubLayer << "\n";

  out << "fPosition = ";
  out << simulationParameterMoNA.fPosition.X() << " ";
  out << simulationParameterMoNA.fPosition.Y() << " ";
  out << simulationParameterMoNA.fPosition.Z() << "\n";

  out << "fNeutSize = ";
  out << simulationParameterMoNA.fNeutSize.X() << " ";
  out << simulationParameterMoNA.fNeutSize.Y() << " ";
  out << simulationParameterMoNA.fNeutSize.Z() << "\n";

  out << "fVetoSize = ";
  out << simulationParameterMoNA.fVetoSize.X() << " ";
  out << simulationParameterMoNA.fVetoSize.Y() << " ";
  out << simulationParameterMoNA.fVetoSize.Z() << "\n";

  out << "fSize = ";
  out << simulationParameterMoNA.fSize.X() << " ";
  out << simulationParameterMoNA.fSize.Y() << " ";
  out << simulationParameterMoNA.fSize.Z() << "\n";

  out << "fRotAngle = ";
  out << simulationParameterMoNA.fRotAngle.X() << " ";
  out << simulationParameterMoNA.fRotAngle.Y() << " ";
  out << simulationParameterMoNA.fRotAngle.Z() << "\n";

  int nDetector = (simulationParameterMoNA.fParaNeutDetecMap).size();
//  out << "\n\n";
//  std::map<int,TSimulationParameterNeutronDetector*> map = simulationParameterMoNA.fParaNeutDetecMap;
//  std::map<int,TSimulationParameterNeutronDetector*>::iterator it = map.begin();
//  while (it != map.end()){
//    out << *((*it).second) << " \n";
//      it++;
//  }
  out << nDetector << " detectors \n";

  return out;
}

//_____________________________________________________________________________
TSimulationParameterMoNA::TSimulationParameterMoNA()
  : TNamed("parameterMoNA",""),
    fIsLoaded(false),
    fNeutNum(0), fVetoNum(0), fLayerNum(0), fSubLayerNum(0),
    fNeutNumLayer(0), fVetoNumLayer(0), fNeutNumSubLayer(0), fVetoNumSubLayer(0)
{
  fPosition.SetXYZ(0,0,0);
  fNeutSize.SetXYZ(1,1,1);
  fVetoSize.SetXYZ(0,0,0);
  fSize.SetXYZ(10,10,10);
  fRotAngle.SetXYZ(0,0,0);
}
//_____________________________________________________________________________
TSimulationParameterMoNA::TSimulationParameterMoNA(const char* name, const char* title)
  : TNamed(name, title)
{;}

//_____________________________________________________________________________
TSimulationParameterMoNA::TSimulationParameterMoNA(const TString& name, const TString& title)
  : TNamed(name, title)
{;}

//_____________________________________________________________________________
TSimulationParameterMoNA::~TSimulationParameterMoNA()
{;}
//_____________________________________________________________________________
