
#include "TSimulationParameterNEBULA.hh"
#include "TSimulationParameterNeutronDetector.hh"

#include <iostream>

ClassImp(TSimulationParameterNEBULA)

TSimulationParameterNEBULA* gSimulationParameterNEBULA = 0;

//_____________________________________________________________________________
std::ostream& operator<<(std::ostream& out, const TSimulationParameterNEBULA& simulationParameterNEBULA)
{
  out << "fNeutNum = "<<simulationParameterNEBULA.fNeutNum << "\n";
  out << "fVetoNum = "<<simulationParameterNEBULA.fVetoNum << "\n";
  out << "fLayerNum = "<<simulationParameterNEBULA.fLayerNum << "\n";
  out << "fSubLayerNum = "<<simulationParameterNEBULA.fSubLayerNum << "\n";
  out << "fNeutNumLayer = "<<simulationParameterNEBULA.fNeutNumLayer << "\n";
  out << "fVetoNumLayer = "<<simulationParameterNEBULA.fVetoNumLayer << "\n";
  out << "fNeutNumSubLayer = "<<simulationParameterNEBULA.fNeutNumSubLayer << "\n";
  out << "fVetoNumSubLayer = "<<simulationParameterNEBULA.fVetoNumSubLayer << "\n";

  out << "fPosition = ";
  out << simulationParameterNEBULA.fPosition.X() << " ";
  out << simulationParameterNEBULA.fPosition.Y() << " ";
  out << simulationParameterNEBULA.fPosition.Z() << "\n";

  out << "fNeutSize = ";
  out << simulationParameterNEBULA.fNeutSize.X() << " ";
  out << simulationParameterNEBULA.fNeutSize.Y() << " ";
  out << simulationParameterNEBULA.fNeutSize.Z() << "\n";

  out << "fVetoSize = ";
  out << simulationParameterNEBULA.fVetoSize.X() << " ";
  out << simulationParameterNEBULA.fVetoSize.Y() << " ";
  out << simulationParameterNEBULA.fVetoSize.Z() << "\n";

  out << "fSize = ";
  out << simulationParameterNEBULA.fSize.X() << " ";
  out << simulationParameterNEBULA.fSize.Y() << " ";
  out << simulationParameterNEBULA.fSize.Z() << "\n";

  out << "fRotAngle = ";
  out << simulationParameterNEBULA.fRotAngle.X() << " ";
  out << simulationParameterNEBULA.fRotAngle.Y() << " ";
  out << simulationParameterNEBULA.fRotAngle.Z() << "\n";

  int nDetector = (simulationParameterNEBULA.fParaNeutDetecMap).size();
//  out << "\n\n";
//  std::map<int,TSimulationParameterNeutronDetector*> map = simulationParameterNEBULA.fParaNeutDetecMap;
//  std::map<int,TSimulationParameterNeutronDetector*>::iterator it = map.begin();
//  while (it != map.end()){
//    out << *((*it).second) << " \n";
//      it++;
//  }
  out << nDetector << " detectors \n";

  return out;
}

//_____________________________________________________________________________
TSimulationParameterNEBULA::TSimulationParameterNEBULA()
  : TNamed("parameterNEBULA",""),
    fIsLoaded(false),
    fNeutNum(0), fVetoNum(0), fLayerNum(0), fSubLayerNum(0),
    fNeutNumLayer(0), fVetoNumLayer(0), fNeutNumSubLayer(0), fVetoNumSubLayer(0)
{
  fPosition.SetXYZ(0,0,0);
  fNeutSize.SetXYZ(1,1,1);
  fVetoSize.SetXYZ(0,0,0);
  fSize.SetXYZ(10,10,10);
  fRotAngle.SetXYZ(0,0,0);
}
//_____________________________________________________________________________
TSimulationParameterNEBULA::TSimulationParameterNEBULA(const char* name, const char* title)
  : TNamed(name, title)
{;}

//_____________________________________________________________________________
TSimulationParameterNEBULA::TSimulationParameterNEBULA(const TString& name, const TString& title)
  : TNamed(name, title)
{;}

//_____________________________________________________________________________
TSimulationParameterNEBULA::~TSimulationParameterNEBULA()
{;}
//_____________________________________________________________________________
