
#include "TSimulationParameterNeuLAND.hh"
#include "TSimulationParameterNeutronDetector.hh"

#include <iostream>

ClassImp(TSimulationParameterNeuLAND)

TSimulationParameterNeuLAND* gSimulationParameterNeuLAND = 0;

//_____________________________________________________________________________
std::ostream& operator<<(std::ostream& out, const TSimulationParameterNeuLAND& simulationParameterNeuLAND)
{
  out << "fNeutNum = "<<simulationParameterNeuLAND.fNeutNum << "\n";
  out << "fVetoNum = "<<simulationParameterNeuLAND.fVetoNum << "\n";
  out << "fLayerNum = "<<simulationParameterNeuLAND.fLayerNum << "\n";
  out << "fSubLayerNum = "<<simulationParameterNeuLAND.fSubLayerNum << "\n";
  out << "fNeutNumLayer = "<<simulationParameterNeuLAND.fNeutNumLayer << "\n";
  out << "fVetoNumLayer = "<<simulationParameterNeuLAND.fVetoNumLayer << "\n";
  out << "fNeutNumSubLayer = "<<simulationParameterNeuLAND.fNeutNumSubLayer << "\n";
  out << "fVetoNumSubLayer = "<<simulationParameterNeuLAND.fVetoNumSubLayer << "\n";

  out << "fPosition = ";
  out << simulationParameterNeuLAND.fPosition.X() << " ";
  out << simulationParameterNeuLAND.fPosition.Y() << " ";
  out << simulationParameterNeuLAND.fPosition.Z() << "\n";

  out << "fNeutSize = ";
  out << simulationParameterNeuLAND.fNeutSize.X() << " ";
  out << simulationParameterNeuLAND.fNeutSize.Y() << " ";
  out << simulationParameterNeuLAND.fNeutSize.Z() << "\n";

  out << "fVetoSize = ";
  out << simulationParameterNeuLAND.fVetoSize.X() << " ";
  out << simulationParameterNeuLAND.fVetoSize.Y() << " ";
  out << simulationParameterNeuLAND.fVetoSize.Z() << "\n";

  out << "fSize = ";
  out << simulationParameterNeuLAND.fSize.X() << " ";
  out << simulationParameterNeuLAND.fSize.Y() << " ";
  out << simulationParameterNeuLAND.fSize.Z() << "\n";

  out << "fRotAngle = ";
  out << simulationParameterNeuLAND.fRotAngle.X() << " ";
  out << simulationParameterNeuLAND.fRotAngle.Y() << " ";
  out << simulationParameterNeuLAND.fRotAngle.Z() << "\n";

  int nDetector = (simulationParameterNeuLAND.fParaNeutDetecMap).size();
//  out << "\n\n";
//  std::map<int,TSimulationParameterNeutronDetector*> map = simulationParameterNeuLAND.fParaNeutDetecMap;
//  std::map<int,TSimulationParameterNeutronDetector*>::iterator it = map.begin();
//  while (it != map.end()){
//    out << *((*it).second) << " \n";
//      it++;
//  }
  out << nDetector << " detectors \n";

  return out;
}

//_____________________________________________________________________________
TSimulationParameterNeuLAND::TSimulationParameterNeuLAND()
  : TNamed("parameterNeuLAND",""),
    fIsLoaded(false),
    fNeutNum(0), fVetoNum(0), fLayerNum(0), fSubLayerNum(0),
    fNeutNumLayer(0), fVetoNumLayer(0), fNeutNumSubLayer(0), fVetoNumSubLayer(0)
{
  fPosition.SetXYZ(0,0,0);
  fNeutSize.SetXYZ(1,1,1);
  fVetoSize.SetXYZ(0,0,0);
  fSize.SetXYZ(10,10,10);
  fRotAngle.SetXYZ(0,0,0);
}
//_____________________________________________________________________________
TSimulationParameterNeuLAND::TSimulationParameterNeuLAND(const char* name, const char* title)
  : TNamed(name, title)
{;}

//_____________________________________________________________________________
TSimulationParameterNeuLAND::TSimulationParameterNeuLAND(const TString& name, const TString& title)
  : TNamed(name, title)
{;}

//_____________________________________________________________________________
TSimulationParameterNeuLAND::~TSimulationParameterNeuLAND()
{;}
//_____________________________________________________________________________
