#ifndef TSCINTILLATORLIGHTOUTPUT_HH
#define TSCINTILLATORLIGHTOUTPUT_HH 

#include "TObject.h"

// physical constants
static const Double_t mneutron = 939.565;// MeV
static const Double_t vlight = 29.979;// cm/ns

class TScintillatorLightOutput : public TObject
{
public:
  // Energy loss -> light output for NEBULA
  static Double_t MeVeeRelation_DEMONS(Double_t T, std::string name, Int_t pdgcode);
  static Double_t MeVeeRelation_FOX(Double_t T, std::string name, Int_t pdgcode);
  static Double_t MeVtoMeVee(Double_t Tin, Double_t Tout, std::string name, Int_t pdgcode);



  ClassDef(TScintillatorLightOutput, 1)
};

#endif
